<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Announcement extends CI_Controller {

	function __construct() {
        parent::__construct();
		
		$this->lang->load('account_general', get_language());
		$this->load->model('announcement_model');
    }
	
	public function index()
	{
		save_current_url(base_url() . 'announcement/');
		
		if($this->session->userdata('user_type') && $this->session->userdata('user_type') == MEMBER) {
			$this->lang->load('account_general', get_language());
		
			$data['page_title'] = $this->lang->line('website_name') . ' | ' . $this->lang->line('hf_announcement');
				
			$this->load->view('announcement', $data);
		}
		else {
			redirect('', 'refresh');
		}
	}
	
	public function details($announcement_id = NULL)
	{
		save_current_url(base_url() . 'announcement/details/' . $announcement_id . '/');
		
		if($this->session->userdata('user_type') && $this->session->userdata('user_type') == MEMBER) {
			$this->lang->load('account_general', get_language());
		
			$data = $this->announcement_model->get_announcement_content($announcement_id);
			
			$data['page_title'] = $this->lang->line('website_name') . ' | ' . $this->lang->line('hf_announcement') . ' | ' . $this->lang->line('hf_announcement_details');
				
			$this->load->view('announcement_details', $data);
		}
		else {
			redirect('', 'refresh');
		}
	}
	
	public function getlist()
    {
		if($this->session->userdata('user_type') && $this->session->userdata('user_type') == MEMBER) {
			$this->lang->load('account_general', get_language());
		
			/* Array of database columns which should be read and sent back to DataTables. Use a space where
			 * you want to insert a non-database field (for example a counter or static image)
			 */
			 
			if(strtolower(get_language()) == 'zh-cn') {
				$aColumns = array(
									$this->db->dbprefix('announcements') . '.created_date',
									$this->db->dbprefix('announcements') . '.title_zh_cn',
									$this->db->dbprefix('announcements') . '.announcement_id',
								);
			}	
			else {
				$aColumns = array(
									$this->db->dbprefix('announcements') . '.created_date',
									$this->db->dbprefix('announcements') . '.title_en',
									$this->db->dbprefix('announcements') . '.announcement_id',
								);
			}
			
			// DB table to use
			$sTable = 'announcements';
			//
			
			$iDisplayStart = $this->input->get_post('iDisplayStart', true);
			$iDisplayLength = $this->input->get_post('iDisplayLength', true);
			$iSortCol_0 = $this->input->get_post('iSortCol_0', true);
			$iSortingCols = $this->input->get_post('iSortingCols', true);
			$sSearch = $this->input->get_post('sSearch', true);
			$sEcho = $this->input->get_post('sEcho', true);
		
			// Paging
			if(isset($iDisplayStart) && $iDisplayLength != '-1')
			{
				$this->db->limit($this->db->escape_str($iDisplayLength), $this->db->escape_str($iDisplayStart));
			}
			
			// Ordering
			if(isset($iSortCol_0))
			{
				for($i=0; $i<intval($iSortingCols); $i++)
				{
					$iSortCol = $this->input->get_post('iSortCol_'.$i, true);
					$bSortable = $this->input->get_post('bSortable_'.intval($iSortCol), true);
					$sSortDir = $this->input->get_post('sSortDir_'.$i, true);
		
					if($bSortable == 'true')
					{
						$this->db->order_by($aColumns[intval($this->db->escape_str($iSortCol))], $this->db->escape_str($sSortDir));
					}
				}
			}
			
			/* 
			 * Filtering
			 * NOTE this does not match the built-in DataTables filtering which does it
			 * word by word on any field. It's possible to do here, but concerned about efficiency
			 * on very large tables, and MySQL's regex functionality is very limited
			 */
			if(isset($sSearch) && !empty($sSearch))
			{
				for($i=0; $i<count($aColumns); $i++)
				{
					$bSearchable = $this->input->get_post('bSearchable_'.$i, true);
					
					// Individual column filtering
					if(isset($bSearchable) && $bSearchable == 'true')
					{
						$this->db->or_like($aColumns[$i], $this->db->escape_like_str($sSearch));
					}
				}
			}
			
			// Select Data
			$this->db->select('SQL_CALC_FOUND_ROWS '.str_replace(' , ', ' ', implode(', ', $aColumns)), false);
			$rResult = $this->db->get($sTable);
		
			// Data set length after filtering
			$this->db->select('FOUND_ROWS() AS found_rows');
			$iFilteredTotal = $this->db->get()->row()->found_rows;
		
			// Total data set length
			$iTotal = $this->db->count_all($sTable);
		
			// Output
			$output = array(
				'sEcho' => intval($sEcho),
				'iTotalRecords' => $iTotal,
				'iTotalDisplayRecords' => $iFilteredTotal,
				'aaData' => array()
			);
			
			foreach($rResult->result_array() as $aRow)
			{
				$row = array();
				
				$row[] = date('Y-m-d H:i:s', $aRow['created_date']);
				
				if(strtolower(get_language()) == 'zh-cn') {
					$row[] = $aRow['title_zh_cn'];
				}	
				else {
					$row[] = $aRow['title_en'];
				}
				
				$row[] = '<a class="btn btn-primary btn-sm" href="' . base_url() . 'announcement/details/' . $aRow['announcement_id'] . '/">' . $this->lang->line('announcement_read_more') . '</a>';
				
				$output['aaData'][] = $row;
			}
		
			echo json_encode($output);
		}	
    }
}

/* End of file announcement.php */
/* Location: ./application/controllers/announcement.php */